# -*- sh -*-

# Memory commands for bash shell
#
# Ed.Swarthout@hwdebug.com
#
# Requires zsh or bash version 2.05.0(1)-release (or greater)

function md   { local b=$2; if test -z "$b"; then b=20;fi; rraw $1 $b 4 | od -Ax -t x4z; }
function md4  { local b=$2; if test -z "$b"; then b=20;fi; rraw $1 $b 4 | od -Ax -t x4; }
function md.l { local b=$2; if test -z "$b"; then b=20;fi; rraw $1 $b 4 | od -Ax -t x4z; }
function md.w { local b=$2; if test -z "$b"; then b=20;fi; rraw $1 $b 2 | od -Ax -t x2z; }
function md2  { local b=$2; if test -z "$b"; then b=20;fi; rraw $1 $b 2 | od -Ax -t x2; }
function md.b { local b=$2; if test -z "$b"; then b=20;fi; rraw $1 $b 1 | od -Ax -t x1z; }
function md1  { local b=$2; if test -z "$b"; then b=20;fi; rraw $1 $b 1 | od -Ax -t x1; }

function md.hexs { rraw $@ | od -w -An -t x1 | tr -d ' \n'; echo; }
function md.s  { rraw $@ | strings; }
function md.p  { local b=$2; if test -z "$b"; then b=4;fi; rraw $1 $b 4 | od -An -vt x4 | xargs echo; }
function md.wp { local b=$2; if test -z "$b"; then b=2;fi; rraw $1 $b 2 | od -An -vt x2 | xargs echo; }
function md.bp { local b=$2; if test -z "$b"; then b=1;fi; rraw $1 $b 1 | od -An -vt x1 | xargs echo; }
function md.d  { local b=$2; if test -z "$b"; then b=4;fi; rraw $1 $b 4 | od -An -vt u4 | xargs echo; }
function md.wd { local b=$2; if test -z "$b"; then b=2;fi; rraw $1 $b 2 | od -An -vt u2 | xargs echo; }
function md.bd { local b=$2; if test -z "$b"; then b=1;fi; rraw $1 $b 1 | od -An -vt u1 | xargs echo; }

function mw   { local j=$1; shift; strtoulx -4 $@ | wraw $j 4; }
function mw.l { local j=$1; shift; strtoulx -4 $@ | wraw $j 4; }
function mw.w { local j=$1; shift; strtoulx -2 $@ | wraw $j 2; }
function mw.b { local j=$1; shift; strtoulx -1 $@ | wraw $j 1; }

# mw.bin [-v] Address File
function mw.bin {
    local j=$1
    shift
    if [ $j = "-v" ]; then
	j=$1
	shift
	if [ -z "$1" ]; then return 0; fi # skip if -v and no file
	echo mw.bin $j $1
    fi
    if [ -z "$1" ]; then echo "Filename missing"; return 1; fi
    if [ ! -r "$1" ]; then echo "$1 not readable"; return 1; fi
    local file_size=$(printf "%x" $(ls -l $1 | cut -d' ' -f5))

# direct mmap copy (.9s vs 6.9s for large ramdisk to k memory)
    mmcpraw $1 0 $file_size /dev/mem $j 1;
#    cat $1 | wraw $j 1 $file_size;
}

function mw.zero {
# offset bytes word_size
    if [ -z "$2" ]; then "mw.zero offset bytes <word_size>"; return 1; fi
    mmcpraw /dev/zero 0 $2 /dev/mem $1 $3
}

function mdi4p {
    echo -n "$2 "
    mdi4 $1 $2 $3
}
function mdi4 {
    mw $1 $2
    md.p $( printf "%x" $(( 0x$1 + 4 )) ) $3
}

function mdi2p {
    echo -n "$2 "
    mdi2 $1 $2 $3
}
function mdi2 {
    mw $1 $2
    md.wp $( printf "%x" $(( 0x$1 + 4 + (0x$2 & 2) )) ) $3
}

function mdi1p {
    echo -n "$2 "
    mdi1 $1 $2 $3
}
function mdi1 {
    mw $1 $2
    md.bp $( printf "%x" $(( 0x$1 + 4 + (0x$2 & 3) )) ) $3
}

function mwi4 {
    mw $1 $2
    mw $( printf "%x" $(( 0x$1 + 4 )) ) $3
}
function mwi2 {
    mw $1 $2
    mw.w $( printf "%x" $(( 0x$1 + 4  + (0x$2 & 2) )) ) $3
}
function mwi1 {
    mw $1 $2
    mw.b $( printf "%x" $(( 0x$1 + 4  + (0x$2 & 3) )) ) $3
}
