# -*- sh -*-

# Memory commands for bash shell
#
# define rraw and wraw for mmrraw and mmwraw file commands
# 
# Ed.Swarthout@hwdebug.com
#

function raw_target {
    if test -n "$1" -a -r "$1"; then
	raw_file=$1
    else
	raw_file=/dev/mem
    fi

    if test ! -r "$raw_file"; then 
	echo "Error: \"$raw_file\" not readable."; return 1; 
    fi
}
#echo "Attach to target file with \"raw_target fname\""

function rraw {
# read raw
# args: file offset maxbytes word_size

    local f=$raw_file
    if test -z "$f" -o ! -r "$f"; then f=/dev/mem; fi

    mmrraw $f $1 $2 $3
}

function wraw {
# write raw
# args: file offset word_size maxbytes

    local f=$raw_file
    if test -z "$f" -o ! -r "$f"; then f=/dev/mem; fi

#   echo mmwraw $f $1 $2 $3
    mmwraw $f $1 $2 $3
    local rc=$?
    if [ "$rc" -eq 135 ]; then echo Bus error; fi
    return $rc
}
